/*
 *  Copyright (C) 2020, Loongson Technology Corporation Limited, Inc.
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
*/

#ifndef __ASM_MACH_LOONGSON_2K_H_
#define __ASM_MACH_LOONGSON_2K_H_

#include <linux/io.h>
#include <linux/init.h>
#include <linux/irq.h>
#include <boot_param.h>

/* we need to read back to ensure the write is accepted by conf bus */

#define LS2K_IO_REG_BASE		0x1f000000

/* CHIP CONFIG regs */
#define LS2K_CHIP_CFG_REG_BASE		(LS2K_IO_REG_BASE + 0x00e10000)
#define LS2K_GEN_CONFIG0_REG		(LS2K_CHIP_CFG_REG_BASE + 0x420)

#define USB_PHY01_OFF 0x440
#define USB_PHY23_OFF 0x448


/* USB regs */
#define LS2K_EHCI_REG_BASE		(LS2K_IO_REG_BASE + 0x00e00000)
#define LS2K_OHCI_REG_BASE		(LS2K_IO_REG_BASE + 0x00e08000)


/* REG ACCESS*/
#define ls2k_readb(addr)		(*(volatile unsigned char *)TO_UNCAC(addr))
#define ls2k_readw(addr)		(*(volatile unsigned short *)TO_UNCAC(addr))
#define ls2k_readl(addr)		(*(volatile unsigned int *)TO_UNCAC(addr))
#define ls2k_readq(addr)		(*(volatile unsigned long *)TO_UNCAC(addr))
#define ls2k_writeb(val, addr)	(*(volatile unsigned char *)TO_UNCAC(addr) = (val))
#define ls2k_writew(val, addr)	(*(volatile unsigned short *)TO_UNCAC(addr) = (val))
#define ls2k_writel(val, addr)	(*(volatile unsigned int *)TO_UNCAC(addr) = (val))
#define ls2k_writeq(val, addr)	(*(volatile unsigned long *)TO_UNCAC(addr) = (val))

#endif /* __ASM_MACH_LOONGSON_2K_H_ */
