/* SPDX-License-Identifier: GPL-2.0-only */
/*
 * Copyright (C) 2023 Kylin Corporation
 * Authors: jiangxiujie jiangxiujie@kylinos.cn
 */
#ifndef __ASM_PTDUMP_H
#define __ASM_PTDUMP_H

#ifdef CONFIG_LOONGARCH_PTDUMP_CORE

#include <linux/mm_types.h>
#include <linux/seq_file.h>

struct addr_marker {
	unsigned long start_address;
	char *name;
};

struct ptdump_info {
	struct mm_struct		*mm;
	const struct addr_marker	*markers;
	unsigned long			base_addr;
};

void ptdump_walk_pgd(struct seq_file *s, struct ptdump_info *info);
#ifdef CONFIG_LOONGARCH_PTDUMP_DEBUGFS
int ptdump_debugfs_register(struct ptdump_info *info, const char *name);
#else
static inline int ptdump_debugfs_register(struct ptdump_info *info,
					const char *name)
{
	return 0;
}
#endif
#endif /* CONFIG_LOONGARCH_PTDUMP_CORE */

#endif /* __ASM_PTDUMP_H */
